/* Ant System for Traveling Salesman Problem
by Exhausive Search
Chin-Shiuh Shieh
2002-11-23
*/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define Map             "map.txt"       /* file name of city map */
#define NumberOfCity    12              /* number of cities */

typedef struct {
        float   x;      /* x coordinate */
        float   y;      /* y coordinate */
        } CityType;

CityType        city[NumberOfCity];                     /* city array */
float           delta[NumberOfCity][NumberOfCity];      /* distance matrix */

void main(void)
{
FILE*   mapfpr;         /* file pointer for city map */
float   length,best_length;
int 	r,s,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12;

/* Read city map */
mapfpr=fopen(Map,"r");
for(r=0;r<NumberOfCity;r++)
        fscanf(mapfpr,"%f %f",&(city[r].x),&(city[r].y));
fclose(mapfpr);

/* Evaluate distance matrix */
for(r=0;r<NumberOfCity;r++)
        for(s=0;s<NumberOfCity;s++)
        		{
                delta[r][s]=sqrt((city[r].x-city[s].x)*(city[r].x-city[s].x)+(city[r].y-city[s].y)*(city[r].y-city[s].y));
                if(r==s)delta[r][s]=100.0;
                }

best_length=100.0;

for(i1=0;i1<12;i1++)
for(i2=0;i2<12;i2++)
if(i2!=i1)
for(i3=0;i3<12;i3++)
if(i3!=i1&&i3!=i2)
for(i4=0;i4<12;i4++)
if(i4!=i1&&i4!=i2&&i4!=i3)
for(i5=0;i5<12;i5++)
if(i5!=i1&&i5!=i2&&i5!=i3&&i5!=i4)
for(i6=0;i6<12;i6++)
if(i6!=i1&&i6!=i2&&i6!=i3&&i6!=i4&&i6!=i5)
for(i7=0;i7<12;i7++)
if(i7!=i1&&i7!=i2&&i7!=i3&&i7!=i4&&i7!=i5&&i7!=i6)
for(i8=0;i8<12;i8++)
if(i8!=i1&&i8!=i2&&i8!=i3&&i8!=i4&&i8!=i5&&i8!=i6&&i8!=i7)
for(i9=0;i9<12;i9++)
if(i9!=i1&&i9!=i2&&i9!=i3&&i9!=i4&&i9!=i5&&i9!=i6&&i9!=i7&&i9!=i8)
for(i10=0;i10<12;i10++)
if(i10!=i1&&i10!=i2&&i10!=i3&&i10!=i4&&i10!=i5&&i10!=i6&&i10!=i7&&i10!=i8&&i10!=i9)
for(i11=0;i11<12;i11++)
if(i11!=i1&&i11!=i2&&i11!=i3&&i11!=i4&&i11!=i5&&i11!=i6&&i11!=i7&&i11!=i8&&i11!=i9&&i11!=i10)
for(i12=0;i12<12;i12++)
if(i12!=i1&&i12!=i2&&i12!=i3&&i12!=i4&&i12!=i5&&i12!=i6&&i12!=i7&&i12!=i8&&i12!=i9&&i12!=i10&&i12!=i11)
	{
	length=delta[i1][i2]+delta[i2][i3]+delta[i3][i4]+delta[i4][i5]+delta[i5][i6]+delta[i6][i7]+delta[i7][i8]+delta[i8][i9]+delta[i9][i10]+delta[i10][i11]+delta[i11][i12]+delta[i12][i1];
	if(length<best_length)
		{
		best_length=length;
		printf("%d %d %d %d %d %d %d %d %d %d %d %d %f\n",i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,best_length);
		}
	}
}
